#######################################################################
#                    Global File Location variables                   #
#######################################################################

$sc_cgi_lib_path = "./Library/cgi-lib.pl";
$sc_mail_lib_path = "./Library/mail-lib.pl";
$sc_html_search_routines_library_path = "./Library/web_store_html_search.pl";

$sc_db_lib_path = "./Library/web_store_db_lib.pl";
$sc_order_lib_path = "./Library/web_store_order_lib.pl";
$sc_pgp_lib_path = "./Library/pgp-lib.pl";

$sc_html_setup_file_path = "./Library/web_store_html_lib.pl";
$sc_user_carts_directory_path = "./User_carts";
$sc_data_file_path = "./Data_files/data.file";

$sc_options_directory_path = "./Html/Options/";
$sc_html_product_directory_path = "./Html/Products";
$sc_html_order_form_path = "./Html/outlet_order_form_with_shipping.html";
$sc_store_front_path = "./Html/frames_frontpage.html";

$sc_counter_file_path = "./Admin_files/counter.file";
$sc_error_log_path = "./Admin_files/error.log";
$sc_access_log_path = "./Admin_files/access.log";

$sc_main_script_url = "web_store.cgi";
$sc_order_script_url = "web_store.cgi";

#######################################################################
#                Database Definition Variables                        #
#######################################################################

$db{"product_id"} = 0;
$db{"product"}    = 1;
$db{"price"}      = 2;
$db{"name"}       = 3;
$db{"image_url"}  = 4;
$db{"description"}= 5;
$db{"options"}    = 6;

@sc_db_display_fields = ("Image (If appropriate)",
                         "Description");

@sc_db_index_for_display = ($db{"image_url"},
                            $db{"description"},
                            $db{"options"});

@sc_db_index_for_defining_item_id = 
  ($db{"product_id"},
   $db{"product"},
   $db{"price"},
   $db{"name"},
   $db{"image_url"});

$sc_db_index_of_price = $db{"price"};

#
# Db_variables for searching
#
# All query fields should begin with
# sc_query_ so that they will be passed
# from screen to screen as hidden variables
# if they have value
#
# Special query input form fields are
# sc_db_exact_match = "yes" if no pattern match
# and sc_db_case_sensitive = "yes", if we are doing
# a case insensitive search
#
@sc_db_query_criteria = ("query_price_low_range|2|<=|number",
                         "query_price_high_range|2|>=|number",
                         "product|1|=|string",
                         "keywords|1,2,3,4,5|=|string");

# We want to restrict the number of rows returned 
# so that the browser does not get overloaded
#
$sc_db_max_rows_returned = 25;

#######################################################################
#                    Cart Definition Variables                        #
#######################################################################

# The cart associative array is defined via the following steps:
#
# 1. The 0th field is ALWAYS the quantity of the purchased item
#
# 2. The subsequent fields are the same fields defined 
#    in the @sc_db_index_for_defining_item_id variable.  
#    This is done because whatever is defined in this array,
#    becomes the part of the product defined in the user's cart.
#       
# 3. The field before the next to last field is ALWAYS the   
#    "options" that have been selected by the user.  If you are    
#     not using options, this field still needs to be here. It will
#     just be used as an empty place marker.
#       
# 4. The next to last field is ALWAYS the price
#    after options have been calculated in with the normal price.
#       
# 5. The last field is ALWAYS a computer generated
#    unique identifier to distinguish cart line items from
#    each other.
#

$cart{"quantity"}            = 0;
$cart{"product_id"}          = 1;
$cart{"product"}             = 2;
$cart{"price"}               = 3;
$cart{"name"}                = 4;
$cart{"image_url"}           = 5;
$cart{"options"}             = 6;
$cart{"price_after_options"} = 7;
$cart{"unique_cart_line_id"} = 8;

# This is the index to the original item price
$sc_cart_index_of_price = $cart{"price"};
$sc_cart_index_of_price_after_options = 
  $cart{"price_after_options"};

# this will show the index of another column of our choice
# to measure -- such as weight or volume if we are selling
# something where the weight or volume affects the shipping
# or discount logic.
#
$sc_cart_index_of_measured_value = $cart{"price"};

@sc_cart_display_fields = ("Description", 
                   "Image",
		   "Options",
		   "Price After Options");

# price after options is 6 
# and price before options would be 3

# Index into cart file is the SAME as the index
# into database.... except that quantity has been
# added to the beginning
# and the end has price after options and a unique
# computer generated row id.
#

@sc_cart_index_for_display = 
  ($cart{"name"},
   $cart{"image_url"},
   $cart{"options"},
   $cart{"price_after_options"});                       

$sc_cart_index_of_item_id = $cart{"product_id"};
$sc_cart_index_of_quantity = $cart{"quantity"};

#######################################################################
#                    Order Form Definition Variables                  #
#######################################################################

  %sc_order_form_array =('01-name', 'Name',
                        '02-b_street_address', 'Billing Address Street',
                        '03-b_city', 'Billing Address City',
                        '04-b_state', 'Billing Address State',
                        '05-b_zip', 'Billing Address Zip',
                        '06-b_country', 'Billing Address Country',
                        '07-m_street_adress', 'Mailing Address Street',
                        '08-m_city', 'Mailing Address City',
                        '09-m_state', 'Mailing Address State',
                        '10-m_zip', 'Mailing Address Zip',
                        '11-m_country', 'Mailing Address Country',
                        '12-phone', 'Phone Number',
                        '13-fax', 'Fax Number',
                        '14-e-mail', 'Email',
                        '15-URL', 'URL',
                        '16-link', 'Link',
                        '17-type_of_card', 'Type of Card',
                        '19-cardname', 'Name Appearing on Card',
                        '20-card_number', 'Card Number',
                        '21-ex_date', 'Card Expiration',
			'22-shipping', 'Shipping Method');

  @sc_order_form_required_fields = 
    ("01-name",
     "02-b_street_address",
     "03-b_city",
     "04-b_state",
     "05-b_zip",
     "12-phone",
     "14-e-mail");

  #the following will generate hidden fields with
  #the contents of the cart inside of them.

  $sc_order_with_hidden_fields = "yes";

# increasing numerical value (1,2,3) if its 0,
# then it never gets calculated at this stage
#
  $sc_calculate_discount_at_display_form = 1;
  $sc_calculate_discount_at_process_form = 1;

  $sc_calculate_shipping_at_display_form = 0;
  $sc_calculate_shipping_at_process_form = 1;

  $sc_calculate_sales_tax_at_display_form = 1;
  $sc_calculate_sales_tax_at_process_form = 1;

  @sc_order_form_shipping_related_fields = 
    ("22-shipping");

  @sc_order_form_discount_related_fields =
    ();

# Shipping_logic is an array of criteria of what type of
# shipping cost to apply.
# The first pipe-delimited fields correspond to the
# sc_order_form_shipping_related_fields. 
#
# Subsequent fields correspond to total price, total quantity,
# and total measurement field. If the field is left blank,
# then that total does not enter into the equation of what
# shipping logic to apply.
#
# The last field is the amount of shipping to apply.
# It is either a hard dollar amount or it is a percentage
# (indicated by % sign) that will be applied to the 
# total price of the order.
#
  @sc_shipping_logic = 
     ("ups||1-10||5",
      "ups||11-||10",
      "fedex||1-10||20",
      "fedex||11-||30");

#
# Discount logic is the same as shipping logic except
# that whatever value is calculated for the discount will
# be subtracted rather than added to the grand total.
#
  @sc_discount_logic  = ("|1-||1");

#
# Sales tax is always a percentage of the total order
# 
  $sc_sales_tax = ".05"; # 5%
  $sc_sales_tax_form_variable = "04-b_state";
  @sc_sales_tax_form_values = ("md", "Maryland");

#
# Process Order Variables:
#
$sc_order_email = "you\@yourdomain.com";
$sc_send_order_to_email = "yes";
$sc_send_order_to_log = "no";
$sc_order_log_file = "./Admin_files/order.log";
$sc_order_check_db = "yes";

#
# Do we use PGP Encryption -- WARNING: This is a difficult
# option to setup. You must go into the pgp-lib.pl file
# and edit the pgp variables in the header for your specific
# setup.
#
$sc_use_pgp = "no";
$sc_pgp_temp_file_path = "./Admin_files";

#######################################################################
#                     Store Option Variables                          #
#######################################################################

$sc_use_html_product_pages = "no"; # A yes means that you will not generate
				 # Product pages using a database.
$sc_should_i_display_cart_after_purchase = "no"; # A no means that the
				# client will be sent back to the product
				# page from which they just ordered.
				# A yes means that they will be taken to a
				# page displaying their current cart after
				# every purchase. 

$sc_shall_i_let_client_know_item_added = "yes";
$sc_item_ordered_message = "<H2><CENTER>Your order has been added to your
                            cart! Thank you!</CENTER></H2>";
$sc_shall_i_email_if_error = "yes";
$sc_shall_i_log_errors = "yes";
$sc_shall_i_log_accesses = "yes";

#######################################################################
#                    HTML Search Variables                            #  
#######################################################################

$sc_root_web_path = "/usr/local/etc/httpd/htdocs/Web_store/Html/Products";
$sc_server_url = "http://www.yourdomain.com/Web_store/Html/Products";
@sc_unwanted_files = ('*.cgi');

#######################################################################
#                  Error Message Variables                            #
#######################################################################

$sc_page_load_security_warning = "I am sorry, but you may only use this
	program to view HTML pages.  If you absolutely MUST view non-HTML
	pages within your store, you must modify lines 79-81, but be
	careful, doing so may make your system vulnerable to hackers.";

$sc_randomizer_error_message = "There must be something wrong with your local
	rand function because I cannot get a unique, random number for
	your shopping cart. Please check the call to rand in the Assign a
	Shopping Cart routine.";

#######################################################################
#                  Miscellaneous Variables
#
#######################################################################
 
$sc_admin_email = "you\yourdomain.com";
@acceptable_file_extensions_to_display = (".html", ".htm", ".shtml");
$sc_money_symbol = "Lira";
$sc_money_symbol_placement = "back";
$sc_current_century = "20";
$sc_number_days_keep_old_carts = .5;

$sc_no_frames_button = "";

$sc_product_display_title = "Product Listing";

$sc_product_display_header = qq~
<SCRIPT LANGUAGE="JavaScript">
<!--
function calculateSubtotal() {
  subtotal = 0;
  price = 0;
  quantity = 0;
  for (i = 0 ; i < document.forms[0].elements.length ; i++) {
    if ((document.forms[0].elements[i].name.substring(0,5) == "item-") &&
       (document.forms[0].elements[i].value > 0)) {
      quantity = document.forms[0].elements[i].value;
      itemname = document.forms[0].elements[i].name;
      itemid = itemname.substring(5,itemname.indexOf("|"));
      itemname = itemname.substring(itemname.indexOf("|")+1);
      itemname = itemname.substring(itemname.indexOf("|")+1);
      price  = itemname.substring(0,itemname.indexOf("|"));
      for (j=0;j<document.forms[0].elements.length;j++) {
        optionname = document.forms[0].elements[j].name;
        if (optionname.substring(0,6) == "option") {
          optionid = optionname.substring(
                          optionname.indexOf("|")+1);
          // We strip off TWO pipe fields to get to the ID
          optionid = optionid.substring(
                          optionid.indexOf("|")+1);
          if (optionid == itemid) {
            optionvalue = document.forms[0].elements[j].value;
            // If there is no direct value, we are looking
            // at a select
            optionprice = "0.00";
            if (optionvalue.indexOf("|") < 1) {
              index = document.forms[0].elements[j].selectedIndex;
              optionvalue = 
                document.forms[0].elements[j].options[index].value;
              optionprice = 
                optionvalue.substring(optionvalue.indexOf("|")+1);
            } else { // It is a radio button
              if (document.forms[0].elements[j].checked == true) {
                optionprice = 
                  optionvalue.substring(optionvalue.indexOf("|")+1);
              }
            }
            price = "" + (parseFloat(price) + parseFloat(optionprice));
          }
        }
      }
      subtotal += quantity * price;
    }
    
  }
  // convert subtotal to a string
  subtotaltext = subtotal + "";
  decimalstart = subtotaltext.indexOf(".");
  if (decimalstart > 0) {
    subtotaltext = subtotaltext.substring(0,decimalstart+3);
  }
  if (decimalstart < 1) {
    subtotaltext = subtotaltext + ".00";
  }
  if (subtotaltext.substring(decimalstart+1).length < 2) {
    subtotaltext = subtotaltext + "0";
  } 
  document.forms[0].subtotal.value = subtotaltext;
}
//-->
</SCRIPT>
  <TABLE BORDER = "0">
  <TR>
  <TH>Quantity</TH>
  <TH>%s</TH>
  <TH>%s</TH>
  </TR>
  <TR>
  <TD COLSPAN = "3"><HR></TD>
  </TR>~;

$sc_product_display_footer = qq!
  </TABLE>
  Calculated Subtotal For This Page:
  <INPUT TYPE=TEXT NAME=subtotal VALUE="">
  <INPUT TYPE=BUTTON NAME=calculate VALUE="Calculate"
   OnClick="calculateSubtotal()">
  !;
             
$sc_product_display_row = qq~

  <TR> 
  <TD ALIGN = "center"><INPUT TYPE = "text"
             NAME = "item-%s"
             SIZE = "3" MAXLENGTH = "4">
  </TD>
  <TD ALIGN = "center">%s</TD>
  <TD>%s<BR>%s</TD>

  </TR>
  </TR>
  <TR> 
  <TD COLSPAN = "3"><HR></TD>
  </TR>~;

